#include "juego.h"

using namespace STDP;

void Juego::iniciarJuego(int modo){ // modo es el tipo de partida seleccionada desde el menu principal
	modoSeleccionado=modo;
	bool findeljuego = 0;
	mostrarCuentaAtras();
	do{
		bonusActual=tiempoInicial+(nivelActual-1)*incrementoTiempo; //Fórmula para calcular el bonus del nivel
		minasActual=minasInicial+(nivelActual-1)*incrementoMinas; //Fórmula para calcular las minas del nivel
		int posicionMinas[minasInicial+nivelActual*incrementoMinas][2]; //Cadena de posiciones de las minas en forma de coordenadas
		int posicionObjetos[15][3]; //Lo mismo con los objetos
		mostrarDatosJuego();
		mostrarBonus();
		mostrarPuntuacion();
		mostrarTablero();
		generarMinas(posicionMinas,posicionObjetos);
		if(modoSeleccionado==1){
			generarObjetos(posicionObjetos,posicionMinas);
			mostrarObjetos(posicionObjetos);
		}

		findeljuego=controlPersonaje(posicionMinas,posicionObjetos);

		if(findeljuego==false)
			findeljuego=pantallaFinNivel();
		if(findeljuego==false){
			nivelActual++;
			puntuacionPartida+=bonusActual;

			//Anulamos todos los objetos por si ha quedado alguno activo
			luz = false;
			controles = false;
			paralisis = false;
			solucion = false;
			desorden = false;
		}

	}while(findeljuego==false);
}

void Juego::mostrarCuentaAtras(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.clearScreen();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(36,11);
	stdp.writeStr("Ready?");
	stdp.refreshScr();
	sleep(1);
	mostrarDatosJuego();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(33,11);
	stdp.writeStr("Really ready?");
	stdp.refreshScr();
	sleep(1);
	mostrarDatosJuego();
	mostrarBonus();
	mostrarPuntuacion();
	stdp.setCursor(0,0);
	stdp.writeChar(' ');
	cout << "\a";
	stdp.setColor(ABOLD, CGREEN, CBLACK);
	stdp.setCursor(38,11);
	stdp.writeStr("GO!");
	stdp.refreshScr();
	sleep(1);
}

void Juego::mostrarDatosJuego(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.clearScreen();
	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(5,1);
	stdp.writeStr("Nivel: ");
	char* nivelConvertido;
	nivelConvertido = new char[3];
	sprintf(nivelConvertido,"%d",nivelActual); //Convertimos el entero a cadena de caracteres
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(nivelConvertido);

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(25,2);
	stdp.writeStr("Minas: ");
	char* minasConvertido;
	minasConvertido = new char[3];
	sprintf(minasConvertido,"%d",minasActual);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(minasConvertido);

}

void Juego::restarBonus(){
	if(bonusActual>0)
		bonusActual--;
	usleep(75000);
}

void Juego::mostrarBonus(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(5,2);
	stdp.writeStr("             ");
	stdp.setCursor(5,2);
	stdp.writeStr("Bonus: ");
	char* bonusConvertido;
	bonusConvertido = new char[8];
	sprintf(bonusConvertido,"%d",bonusActual);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(bonusConvertido);
}

void Juego::mostrarPuntuacion(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CBLUE, CBLACK);
	stdp.setCursor(25,1);
	stdp.writeStr("                   ");
	stdp.setCursor(25,1);
	stdp.writeStr("Puntuacion: ");
	char* puntuacionConvertida;
	puntuacionConvertida = new char[8];
	sprintf(puntuacionConvertida,"%d",puntuacionPartida);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.writeStr(puntuacionConvertida);
}

void Juego::mostrarTablero(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	for(int i = 0; i<21;i++){
		for(int j = 0;j<36;j+=2){
			if(i == 0 || i == 20)
				stdp.setColor(ANORMAL,CGREEN,CBLACK);
			else
				stdp.setColor(ANORMAL, CYELLOW, CBLACK);
			stdp.setCursor(22+j,3+i);
			stdp.writeStr("# ");
		}
	}

	stdp.refreshScr();
}

bool Juego::controlPersonaje(int posicionMinas[][2],int posicionObjetos[15][3]){
	int maxAvance=23;
	bool mina = 0;
	bool objeto = 0;
	int j = 0;

	int numeroPulsaciones = 0;
	int numeroMovimientos = 0;

	int teclacontrol[4];
	teclacontrol[0]=KDOWN;
	teclacontrol[1]=KRIGHT;
	teclacontrol[2]=KLEFT;
	teclacontrol[3]=KUP;

	int teclapulsada=0;
	int minasAlrededor=0;
	int posicionPersonaje[2];
	int posicionAnterior[2];
	posicionAnterior[0]=0;
	posicionAnterior[1]=0;
	char* minasAlrededorConvertida;
	minasAlrededorConvertida = new char[2];
	posicionPersonaje[1]=23;
	do{
		posicionPersonaje[0]=rand() % 35 + 22;
	}while(posicionPersonaje[0]%2!=0);
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	do{
		objeto=false;
		stdp.setColor(ABOLD,CBLUE,CBLACK);
		stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
		stdp.writeChar('@');

		teclapulsada=stdp.getKey();

		minasAlrededor=0;
		for(int i = 0; i<(minasInicial+(nivelActual-1)*incrementoMinas) && mina==false;i++){

			if(posicionPersonaje[1]==posicionMinas[i][1] && posicionPersonaje[0]+2==posicionMinas[i][0])
				minasAlrededor++;
			if(posicionPersonaje[1]==posicionMinas[i][1] && posicionPersonaje[0]-2==posicionMinas[i][0])
				minasAlrededor++;
			if(posicionPersonaje[1]+1==posicionMinas[i][1] && posicionPersonaje[0]==posicionMinas[i][0])
				minasAlrededor++;
			if(posicionPersonaje[1]-1==posicionMinas[i][1] && posicionPersonaje[0]==posicionMinas[i][0])
				minasAlrededor++;
			if(posicionPersonaje[1]+1==posicionMinas[i][1] && posicionPersonaje[0]+2==posicionMinas[i][0])
				minasAlrededor++;
			if(posicionPersonaje[1]-1==posicionMinas[i][1] && posicionPersonaje[0]+2==posicionMinas[i][0])
				minasAlrededor++;
			if(posicionPersonaje[1]+1==posicionMinas[i][1] && posicionPersonaje[0]-2==posicionMinas[i][0])
				minasAlrededor++;
			if(posicionPersonaje[1]-1==posicionMinas[i][1] && posicionPersonaje[0]-2==posicionMinas[i][0])
				minasAlrededor++;
			if(posicionPersonaje[1]==posicionMinas[i][1] && posicionPersonaje[0]==posicionMinas[i][0]){
				mina=true;
				minasAlrededor=0;
			}
		}

		if(modoSeleccionado==1){
			for(j = 0; j<15 && objeto==false;j++){
				if(posicionPersonaje[1]==posicionObjetos[j][1] && posicionPersonaje[0]==posicionObjetos[j][0]){
					objeto=true;
				}
			}
			j--;
		}

		stdp.setColor(ABOLD, CBLUE, CBLACK);
		stdp.setCursor(50,1);
		stdp.writeStr("Minas Alrededor: ");
		sprintf(minasAlrededorConvertida,"%d",minasAlrededor);
		if(minasAlrededor!=0)
			stdp.setColor(ANORMAL, CRED, CBLACK);
		else
			stdp.setColor(ANORMAL, CGREEN, CBLACK);


		if(mina==true){
			stdp.setColor(ANORMAL, CRED, CBLACK);
			stdp.writeStr(minasAlrededorConvertida);
			for(int j = 0; j<5; j++){
				stdp.setColor(ABOLD,CRED,CBLACK);
				stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
				stdp.writeChar('=');
				stdp.refreshScr();
				usleep(100000);
				stdp.setColor(ABOLD,CBLUE,CBLACK);
				stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
				stdp.writeChar('@');
				stdp.refreshScr();
				usleep(100000);
				stdp.setCursor(0,0);
				stdp.writeChar(' ');
				cout << "\a";
			}
			if(luz == true){
				mostrarTablero();
				mostrarObjetos(posicionObjetos);
			}
			mostrarMinas(posicionMinas);
			stdp.setColor(ABOLD,CGREEN,CBLACK);
			stdp.setCursor(67,10);
			stdp.writeStr("Pulsa");
			stdp.setCursor(66,12);
			stdp.writeStr("Espacio");
			do{
			}while(stdp.getKey()!=KSPACE);
		}

		else{
			stdp.writeStr(minasAlrededorConvertida);
			mostrarPuntuacion();
			restarBonus();
			mostrarBonus();

			if(modoSeleccionado==1){
				if (objeto==true && (posicionAnterior[0]!=posicionPersonaje[0] || posicionAnterior[1]!=posicionPersonaje[1])){
					stdp.setCursor(0,0);
					stdp.writeChar(' ');
					cout << "\a";

					if(posicionObjetos[j][2]==0){
						luz = !luz;
						stdp.clearScreen();

						mostrarDatosJuego();
						mostrarBonus();
						mostrarPuntuacion();
						if(luz == false)
							mostrarTablero();
						mostrarObjetos(posicionObjetos);
						stdp.setColor(ABOLD,CBLUE,CBLACK);
						stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
						stdp.writeChar('@');
						stdp.refreshScr();

					}
					if(posicionObjetos[j][2]==1){
						desorden=true;
						generarMinas(posicionMinas,posicionObjetos);
						desorden=false;
					}
					if(posicionObjetos[j][2]==2){
						controles = !controles;
						if(controles == true){
							teclacontrol[0]=KUP;
							teclacontrol[1]=KLEFT;
							teclacontrol[2]=KDOWN;
							teclacontrol[3]=KRIGHT;
						}
						else{
							teclacontrol[0]=KDOWN;
							teclacontrol[1]=KRIGHT;
							teclacontrol[2]=KLEFT;
							teclacontrol[3]=KUP;
						}
					}

					if(posicionObjetos[j][2]==3){
						mostrarMinas(posicionMinas);
						sleep(1);
						stdp.setColor(ANORMAL, CYELLOW, CBLACK);

						for(int i = 0; i<(minasInicial+(nivelActual-1)*incrementoMinas);i++){
							stdp.setCursor(posicionMinas[i][0],posicionMinas[i][1]);
							if(luz == false)
								stdp.writeChar('#');
							else
								stdp.writeChar(' ');
						}
						stdp.refreshScr();

					}
					if(posicionObjetos[j][2]==4){

						stdp.clearScreen();
						mostrarDatosJuego();
						mostrarBonus();
						mostrarPuntuacion();
						if(luz == false)
							mostrarTablero();
						mostrarObjetos(posicionObjetos);
						stdp.setColor(ABOLD,CBLUE,CBLACK);
						stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
						stdp.writeChar('@');
						stdp.refreshScr();
					}

					posicionObjetos[j][0]=0;
					posicionObjetos[j][1]=0;

					posicionAnterior[0]=posicionPersonaje[0];
					posicionAnterior[1]=posicionPersonaje[1];
				}
			}


			if(teclapulsada==KESCAPE){
				stdp.setColor(ABOLD,CGREEN,CBLACK);
				stdp.setCursor(6,12);
				stdp.writeStr("*PAUSA*");
				do{
				}while(stdp.getKey()!=KESCAPE);
				stdp.setColor(ABOLD,CGREEN,CBLACK);
				stdp.setCursor(6,12);
				stdp.writeStr("       ");
			}

			if(numeroMovimientos > 0){
				if(numeroPulsaciones == 25)
					numeroMovimientos--;

				if(numeroMovimientos == 0)
					paralisis = false;
				numeroPulsaciones--;
			}


			if(teclapulsada==teclacontrol[1] && posicionPersonaje[0]!=56 && numeroPulsaciones == 0){
				stdp.setColor(ABOLD,CWHITE,CBLACK);
				stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
				if(posicionPersonaje[1]!=23)
					stdp.writeChar('+');
				else{
					stdp.setColor(ABOLD,CGREEN,CBLACK);
					stdp.writeChar('#');
				}

				posicionPersonaje[0]+=2;
			}
			else if(teclapulsada==teclacontrol[2] && posicionPersonaje[0]!=22 && numeroPulsaciones == 0){
				stdp.setColor(ABOLD,CWHITE,CBLACK);
				stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
				if(posicionPersonaje[1]!=23)
					stdp.writeChar('+');
				else{
					stdp.setColor(ABOLD,CGREEN,CBLACK);
					stdp.writeChar('#');
				}
				posicionPersonaje[0]-=2;
			}
			else if(teclapulsada==teclacontrol[3] && posicionPersonaje[1]!=3 && numeroPulsaciones == 0){
				stdp.setColor(ABOLD,CWHITE,CBLACK);
				stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
				if(posicionPersonaje[1]!=23)
					stdp.writeChar('+');
				else{
					stdp.setColor(ABOLD,CGREEN,CBLACK);
					stdp.writeChar('#');
				}
				posicionPersonaje[1]--;
			}
			else if(teclapulsada==teclacontrol[0] && posicionPersonaje[1]!=23 && numeroPulsaciones == 0){
				stdp.setColor(ABOLD,CWHITE,CBLACK);
				stdp.setCursor(posicionPersonaje[0],posicionPersonaje[1]);
				if(posicionPersonaje[1]!=23)
					stdp.writeChar('+');
				else{
					stdp.setColor(ABOLD,CGREEN,CBLACK);
					stdp.writeChar('#');
				}
				posicionPersonaje[1]++;
			}

			if(maxAvance>posicionPersonaje[1]){
				maxAvance=posicionPersonaje[1];
				puntuacionPartida+=puntosPorAvance;
			}
			if(paralisis == true && numeroPulsaciones == 0)
				numeroPulsaciones = 25;
		}

	}while(posicionPersonaje[1]!=3 && mina == false);

	return(mina);
}

void Juego::generarMinas(int posicionMinas[][2],int posicionObjetos[15][3]){
	bool repeat;
	int i = 0;
	do{
		repeat=0;
		do{
			posicionMinas[i][0]=rand() % 35 + 22;
			posicionMinas[i][1]=rand() % 19 + 4;
		}while(posicionMinas[i][0]%2!=0);

		for(int j=0; j<(minasInicial+(nivelActual-1)*incrementoMinas) && j<i;j++){
			if(j!=i)
				if(posicionMinas[i][0]==posicionMinas[j][0] && posicionMinas[i][1]==posicionMinas[j][1])
					repeat=1;
			if(desorden == true){
				for(int k=0; k<15; k++){
					if(posicionMinas[i][0]==posicionObjetos[k][0] && posicionMinas[i][1]==posicionObjetos[k][1])
						repeat=1;
				}
			}
		}

		if(repeat==0)
			i++;

	}while(i<(minasInicial+(nivelActual-1)*incrementoMinas));
}

void Juego::generarObjetos(int posicionObjetos[15][3],int posicionMinas[][2]){
	bool repeat;
	int i = 0;
	do{
		repeat=0;
		do{
			posicionObjetos[i][0]=rand() % 35 + 22;
			posicionObjetos[i][1]=rand() % 19 + 4;
			posicionObjetos[i][2]=rand() % 5;
		}while(posicionObjetos[i][0]%2!=0);

		for(int j=0; j<15 && j<i;j++){

			if(j!=i)
				if(posicionObjetos[i][0]==posicionObjetos[j][0] && posicionObjetos[i][1]==posicionObjetos[j][1])
					repeat=1;
			for(int k=0; k<(minasInicial+(nivelActual-1)*incrementoMinas); k++){
							if(posicionObjetos[i][0]==posicionMinas[k][0] && posicionObjetos[i][1]==posicionMinas[k][1])
								repeat=1;
			}
		}

		if(repeat==0)
			i++;

	}while(i<15);
}

void Juego::mostrarMinas(int posicionMinas[][2]){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	stdp.setColor(ANORMAL, CRED, CBLACK);
	for(int i = 0; i<(minasInicial+(nivelActual-1)*incrementoMinas);i++){
		stdp.setCursor(posicionMinas[i][0],posicionMinas[i][1]);
		stdp.writeChar('=');
	}
	stdp.refreshScr();

}

void Juego::mostrarObjetos(int posicionObjetos[15][3]){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	for(int i = 0; i<15;i++){
		if(posicionObjetos[i][0] != 0 || posicionObjetos[i][1] != 0){
			stdp.setCursor(posicionObjetos[i][0],posicionObjetos[i][1]);
			stdp.setColor(ANORMAL, CWHITE, CBLACK);
			if(posicionObjetos[i][2]==0){
				stdp.writeChar('?');
			}
			if(posicionObjetos[i][2]==1){
				stdp.writeChar('$');
			}
			if(posicionObjetos[i][2]==2){
				stdp.writeChar('%');
			}
			if(posicionObjetos[i][2]==3){
				stdp.writeChar('!');
			}
			if(posicionObjetos[i][2]==4){
				stdp.writeChar('<');
			}
		}
	}

	stdp.setColor(ANORMAL, CCYAN, CBLACK);
	stdp.setCursor(60,16);
	stdp.writeStr("? -> Bombilla");
	stdp.setCursor(60,17);
	stdp.writeStr("$ -> Cambia-minas");
	stdp.setCursor(60,18);
	stdp.writeStr("% -> Whisky");
	stdp.setCursor(60,19);
	stdp.writeStr("! -> Brújula");
	stdp.setCursor(60,20);
	stdp.writeStr("< -> Apoptosis");


	stdp.refreshScr();

}

int Juego::pantallaFinNivel(){
	bool posicion=0;
	int teclapulsada=0;
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);

	stdp.clearScreen();
	stdp.setColor(AUNDERLINE, CYELLOW, CBLACK);
	stdp.setCursor(33,9);
	stdp.writeStr("¡BIEN HECHO!");
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(34,11);
	stdp.writeStr("¿Seguimos?");

	stdp.setColor(ANORMAL, CGREEN, CBLACK);
	stdp.setCursor(36,13);
	stdp.writeStr("Si");
	stdp.setColor(ANORMAL, CRED, CBLACK);
	stdp.setCursor(40,13);
	stdp.writeStr("No");

	stdp.setColor(ABOLD, CBLUE, CBLACK);
	do{
		teclapulsada=stdp.getKey();
		if(posicion==0){
			stdp.setCursor(35,13);
			stdp.writeChar('*');
			stdp.setCursor(39,13);
			stdp.writeChar(' ');
		}
		else{
			stdp.setCursor(39,13);
			stdp.writeChar('*');
			stdp.setCursor(35,13);
			stdp.writeChar(' ');
		}

		if(teclapulsada==KRIGHT)
			posicion=1;
		if(teclapulsada==KLEFT)
			posicion=0;
		stdp.refreshScr();
	}while(teclapulsada!=KSPACE);

	return(posicion);
}
